/*
    DB Port
    Copyright (C) 2010 Daniel Mewes
*/

package dbport;

import java.util.*;

import systeminterface.*;
import metadata.*;

class CreateIndexPage extends HtmlPage {
    public static String getContent(DbEnvironment environment, String[] arguments) throws Exception {
        StringBuffer result = new StringBuffer();
        
        result.append(getHtmlHead());
        
        if (arguments.length > 0) {
            // Try to create index
            
            String name = null;
            String table = null;
            String attribute = null;
            String range = null;
            
            for (String arg : arguments) {
                if (arg.length() >= 5 && arg.substring(0, 5).equals("name="))
                    name = arg.substring(5);
                else if (arg.length() >= 10 && arg.substring(0, 10).equals("attribute="))
                    attribute = arg.substring(10);
                else if (arg.length() >= 6 && arg.substring(0, 6).equals("table="))
                    table = arg.substring(6);
                else if (arg.length() >= 6 && arg.substring(0, 6).equals("range="))
                    range = arg.substring(6);
                else {
                    result.append("<h1>Invalid argument</h1>");
                    break;
                }
            }
            
            if (name != null && table != null && attribute != null) {
                boolean rangeIndex = false;
                if (range != null && range.equals("true"))
                    rangeIndex = true;
                
                if (rangeIndex)
                    result.append("<h1>Range index created</h1>");
                else
                    result.append("<h1>Index created</h1>");
                
                result.append("Index name: " + name + "<br><br>");
                    
                result.append("Table name: " + table + "<br><br>");
                
                result.append("Attribute: " + attribute + "<br><br>");
                
                environment.database.getIndexInterface().createIndex(name, table, attribute, rangeIndex);
            }
            else
                result.append("<h1>Missing argument</h1>");
        }
        else {
            result.append("<h1>Create index</h1>");
            
            result.append("<form method=\"get\" action=\"#\">\n");
            result.append("<table border=\"0\">\n");
            
            result.append("<tr><td>Name: </td>");
            result.append("<td><input name=\"name\"></td>");
            result.append("</tr>");
            
            result.append("<tr><td>Table: </td>");
            result.append("<td><input name=\"table\"></td>");
            result.append("</tr>");
            
            result.append("<tr><td>Attribute: </td>");
            result.append("<td><input name=\"attribute\"></td>");
            result.append("</tr>");
            
            result.append("<tr><td>Range Index: </td>");
            result.append("<td><input type=\"checkbox\" name=\"range\" value=\"true\"></td>");
            result.append("</tr>");
            
            result.append("</table>");
            result.append("<input type=\"submit\">");
            result.append("</form>");
        }
        
        result.append(getHtmlTail());
        
        return result.toString();
    }
}
