/*
    DB Port
    Copyright (C) 2010 Daniel Mewes
*/

package dbport;

import systeminterface.*;

class DropIndexPage extends HtmlPage {
    public static String getContent(DbEnvironment environment, String[] arguments) throws Exception {
        StringBuffer result = new StringBuffer();
        
        result.append(getHtmlHead());
        
        if (arguments.length > 0) {
            // Try to drop table
            
            String name = null;
            
            for (String arg : arguments) {
                if (arg.length() >= 5 && arg.substring(0, 5).equals("name="))
                    name = arg.substring(5);
                else {
                    result.append("<h1>Invalid argument</h1>");
                    break;
                }
            }
            
            if (name != null) {                                
                result.append("<h1>Index dropped</h1>");
                result.append("Index name: " + name);
                
                environment.database.getIndexInterface().dropIndex(name);
            }
            else
                result.append("<h1>Missing argument</h1>");
        }
        else {
            result.append("<h1>Drop index</h1>");
            
            result.append("<form method=\"get\" action=\"#\">\n");
            result.append("<table border=\"0\">\n");
            
            result.append("<tr><td>Name: </td>");
            result.append("<td><input name=\"name\"></td>");
            result.append("</tr>");
            
            result.append("</table>");
            result.append("<input type=\"submit\">");
            result.append("</form>");
        }
        
        result.append(getHtmlTail());
        
        return result.toString();
    }
}
