/*
    DB Port
    Copyright (C) 2010 Daniel Mewes
*/

package dbport;

import java.util.*;
import java.net.*;
import java.io.*;

class Listener {

    private ServerSocket socket;
    private DbEnvironment environment;

    public Listener(String hostname, int port, DbEnvironment environment) throws IOException {
        socket = new ServerSocket();
        socket.bind(new InetSocketAddress(hostname, port));
        this.environment = environment;
    }
    
    
    public void listen() throws IOException {
        environment.listening = true;
        while (environment.listening) {
            Socket connection = socket.accept();
            ConnectionHandler handler = new ConnectionHandler(connection, environment);
            handler.start();
        }
    }   

}
